# A horizontal sundial with a longitude correction, text and graphics
# www.illustratingshadows.com               # January 6, 2013

use English;
#                                           # http://perldoc.perl.org/Math/Trig.html#TRIGONOMETRIC-FUNCTIONS
use Math::Trig;                             # needs "use Math::Trig;" as "atan2" is worthless
                                            # also TAN is in math.trig, otherwise you must
                                            # do sin/cos. But the big deal is TAN vs ATAN2

print "\n*** Illustrating Shadows PERL *** hDial Jan 5, 2014\n";

print "\nEnter a latitude as nn.n   ";
$latitude = readline(*STDIN);

print "\nEnter a longitude offset (+ is west, - is east) as nn.n    ";
$longitude = -readline(*STDIN);

$slat = sin($latitude*2*3.14159/360);

# now start the graphics stuff
use Tkx;

$mw = Tkx::widget->new(".");
# http://www.tkdocs.com/tutorial/canvas.html
$canvas = $mw->new_tk__canvas(-width => 800, -height => 600, -background => "yellow") ;
$canvas->g_grid(-column=>0, -row=>0);

$canvas->create_text(200,20,-text=>"HORIZONTAL SUNDIAL",-anchor=>"e");
$canvas->create_text(500,20,-text=>"www.illustratingshadows.com",-anchor=>"e");
$canvas->create_text(200,40,-text=>"LATITUDE",-anchor=>"e");
$canvas->create_text(300,45,-text=>$latitude,-anchor=>"e");
$canvas->create_text(200,60,-text=>"LONGITUDE OFFSET",-anchor=>"e");
$canvas->create_text(300,60,-text=>-$longitude,-anchor=>"e");

$hr=-5;
while ($hr<6) {                              # NOTE: ctrl-C will break a loop in Windows 8

    # following does not need "use Math::Trig;" however, it is needed for ATAN etc
    # $hlaTAN = $slat ;
    # $hlaTAN = $hlaTAN * sin(15*($hr+($longitude*4/60)))*2*3.14159/360) ;
    # $hlaTAN = $hlaTAN / cos(15*($hr+($longitude*4/60)))*2*3.14159/360) ;

    $hlaTAN = $slat * Math::Trig::tan(15*($hr+($longitude*4/60))*2*3.14159/360);

    $hla    = atan($hlaTAN);                 # needs "use Math::Trig;" as "atan2" is worthless
    $hla    = $hla*360/(2*3.14159);

    # http://alvinalexander.com/blog/post/perl/reference-page-perl-printf-formatting-format-cheat-sheet
    print "\nhour is: " , $hr+12 ," hour line angle is: ";
    printf("%.2f", $hla);
    $thla=sprintf("%.2f", $hla);
    #
    $xc=400;
    $yc=500;
    $radial = 350;
    $y=$radial*cos($hla*2*3.14159/360);
    $x=$radial*sin($hla*2*3.14159/360);
    $canvas->create_line($xc,$yc,   $xc+$x,$yc-$y);
    $canvas->create_text($xc+$x,$yc-$y,-text=>$thla);
    $canvas->create_text($xc+$x,$yc+10-$y,-text=>(12+$hr));

    $hr = $hr + 1;
}

# draw gnomon
    $canvas->create_line($xc,$yc,         $xc+0,$yc-200);
    $x = 200*sin($latitude*2*3.14159/360);
    $canvas->create_line($xc,$yc-200,     $xc+$x,$yc-200);
    $canvas->create_line($xc,$yc,         $xc+$x,$yc-200);
    $canvas->create_text($xc+$x+10,$yc-200,-text=>"LAT:",-anchor=>"e");
    $canvas->create_text($xc+$x+30,$yc-200,-text=>$latitude,-anchor=>"e");

Tkx::MainLoop();

print "\nThe End\n";

# END #



