package sunDialClass;   # file name does not have to be class name

# Class for storing data about a sundial

#sunDialClass.pm
use warnings;
use strict;
use Math::Trig;

# constructor ~ is a method in the class as it is in this package
sub new {
    # my $self = {};
    # bless ($self, "sunDial");
    # return $self;
    
    # for inheritance, we would use the following
    my $class = shift;
    # shift without any arguments means shift @_ which
    #       takes the first element of the argument array.
    #       page 15 of chapter 11, or 349 of the entire online book
    my $self = {@_};
    bless($self, $class);
    return $self;
}

# method to get a dial name ~ is a method in the class as it is in this package

# method to set an hour ~ is a method in the class as it is in this package
sub setHr {
    my $self  = shift;     # 1st shift is the object
    my $data  = shift;     # 2ns shift is the parameter
    # shift without any arguments means shift @_ which
    #       takes the first element of the argument array.
    #       page 15 of chapter 11, or 349 of the entire online book
    $self->{hrIs} = $data ;
}

# method to get an hour line angle ~ is a method in the class as it is in this package
sub getHla {
     my $self = shift;
     my $sLat = sin( $self->{latIs}*2*3.14159/360 );
     my $tHa  = tan(((15*($self->{hrIs}-12))-($self->{lngIs}-$self->{refIs}))*2*3.14159/360);
     my $Hla  = atan( $sLat * $tHa )  * 360 / (2*3.14159) ;
     return $Hla;
}

1;   # the "1" is a TRUE telling Perl the package loaded ok
